from Products.validation.interfaces.IValidator import IValidator

class FibonacciValidator:
    __implements__ = IValidator

    def __init__(self, name, title='', description=''):
        self.name = name
        self.title = title or name
        self.description = description

    def __call__(self, value, *args, **kwargs):

        # value must be integer
        try:
            value = int(value)
        except:
            return("'%s' is not an integer (illegal value)" % str(value))

        # deal with negative and trivial cases first
        if value < 0:
            return("'%s' is negative (illegal value)" % str(value))
        elif value==0 or value==1:
            return 1
        else:
            low = 0
            high = 1

            # stop if the largest fibonacci is bigger than value
            while value > high:
                # do you remember how fibonacci numbers are defined?
                # hint: F(n+1) = F(n) + F(n-1)
                (low, high) = (high, low + high)

            if value==low or value==high:
                return 1
                    
            # we got this far - return error message
            return("'%d' is not a fibonacci number - try '%d'") % (value, high)

        # If we get this far something really bad happened
        # perhaps integer overflow or something else reallt annoying
        return "Congratulations, you entered a really bad number [:)]-|--<"
